﻿using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GeneicoLabelDesigner
{
    public class BarcodeTool:BitmapTool
    {
        //Assigning tool name
        internal static string toolName = "BarcodeTool";
        internal Image img = null;
        public BarcodeTool(DiagramController src)
        : base(src)
        {
            this.ActionCursor = Cursors.Arrow;
            this.Name = toolName;
            this.SingleActionTool = false;
        }

        protected override Node CreateNode(RectangleF rectBounding)
        {

            BitmapNode barNode = new BitmapNode(DiagramSample.Properties.Resources.templateBarcode);
            barNode.PropertyBag.Add("Type", "Barcode");
            barNode.PropertyBag.Add("BarcodeType", "EAN13");
            barNode.PropertyBag.Add("Content", "123456789012");
            barNode.PinPoint = new PointF(rectBounding.Location.X + rectBounding.Width / 2, rectBounding.Location.Y + rectBounding.Height / 2);
            barNode.Size =  new SizeF(rectBounding.Size.Width, rectBounding.Size.Height);
            //barNode.LineStyle.LineWidth = 0;

            return barNode;
        }

    }
}