﻿using Syncfusion.Windows.Forms.Diagram;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GeneicoLabelDesigner.Infrastructure.Tools
{
    public class CustomBitmapTool : BitmapTool
    {
        //Assigning tool name
        internal static string toolName = "CustomBitmapTool";
        internal Image img = null;

        public CustomBitmapTool(DiagramController src)
        : base(src)
        {
            this.ActionCursor = Cursors.Arrow;
            this.Name = toolName;
            this.SingleActionTool = false;
        }

        protected override Node CreateNode(RectangleF rectBounding)
        {
            OpenFileDialog ofd = new OpenFileDialog
            {
                InitialDirectory = @"D:\",
                Title = "Select Image",

                CheckFileExists = true,
                CheckPathExists = true,
                Multiselect = false,

                DefaultExt = "bmp",
                Filter = "Images (*.BMP;*.JPG;*.GIF,*.PNG,*.TIFF)|*.BMP;*.JPG;*.GIF;*.PNG;*.TIFF|" +
"All files (*.*)|*.*",
                FilterIndex = 2,
                RestoreDirectory = true

                //ReadOnlyChecked = true,
                //ShowReadOnly = true
            };

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                Bitmap bm = new Bitmap(ofd.FileName);
                BitmapNode barNode = new BitmapNode(bm);
                barNode.PropertyBag.Add("Type", "Bitmap");
                barNode.PropertyBag.Add("Path", ofd.FileName);
                barNode.PinPoint = new PointF(rectBounding.Location.X + rectBounding.Width / 2, rectBounding.Location.Y + rectBounding.Height / 2);
                barNode.Size = new SizeF(rectBounding.Size.Width, rectBounding.Size.Height);
                barNode.LineStyle.LineWidth = 0;

                return barNode;
            }
            else
                return null;

        }
    }
}
