﻿using GeneicoLabelDesigner;
using GeneicoLabelDesigner.Infrastructure.Tools;
using Syncfusion.Windows.Forms.Diagram;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DiagramSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.diagram1.Model.BoundaryConstraintsEnabled = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitializeDiagram();
            diagram1.Controller.RegisterTool(new CustomBitmapTool(diagram1.Controller));
            diagram1.Controller.RegisterTool(new BarcodeTool(diagram1.Controller));
        }

        private void InitializeDiagram()
        {
            this.document.CustomUnitValue = 1;           

            diagram1.Model = document;
            diagram1.Controller.Guides.LineStyle.LineColor = Color.FromArgb(255, 153, 51);
            diagram1.View.Grid.GridStyle = GridStyle.Line;
            diagram1.View.Grid.DashStyle = DashStyle.Dot;
            diagram1.View.Grid.Color = Color.Black;
            diagram1.View.Grid.VerticalSpacing = 5;
            diagram1.View.Grid.HorizontalSpacing = 5;
            // diagram1.Model.BackgroundStyle.GradientCenter = 0.5f;
            diagram1.View.HandleRenderer.HandleColor = Color.BlanchedAlmond;
            diagram1.View.HandleRenderer.HandleOutlineColor = Color.Green;
            diagram1.Model.RenderingStyle.SmoothingMode = SmoothingMode.HighQuality;
            // diagram1.Model.MeasurementUnits = MeasureUnits.Document;
            diagram1.ShowRulers = true;

            this.diagram1.RulersHeight = 20;

           

            diagram1.View.SelectionList.Clear();
        }
        private void btnBarcode_Click(object sender, EventArgs e)
        {
            SetActiveTool("BarcodeTool");
        }

        private void btnImage_Click(object sender, EventArgs e)
        {
            SetActiveTool("CustomBitmapTool");
        }


        private void SetActiveTool(string toolName)
        {
            this.diagram1.Controller.ActivateTool(toolName);
        }

        private void tsTools_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            ToolStrip tool = sender as ToolStrip;
            foreach (ToolStripButton selecteditem in tool.Items)
            {
                if (selecteditem.BackColor == Color.LightBlue)
                {
                    selecteditem.BackColor = System.Drawing.Color.Transparent;
                }
            }
            e.ClickedItem.BackColor = Color.LightBlue;
        }

        private void diagram1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                int i = diagram1.ContextMenuStrip.Items.Count - 1;
                while (diagram1.ContextMenuStrip.Items.Count - 1 != 3)
                {
                    if (diagram1.ContextMenuStrip.Items[i] is ToolStripSeparator)
                    {
                        ToolStripSeparator item = diagram1.ContextMenuStrip.Items[i] as ToolStripSeparator;
                        diagram1.ContextMenuStrip.Items.Remove(item);
                    }
                    else
                    {
                        ToolStripMenuItem item = diagram1.ContextMenuStrip.Items[i] as ToolStripMenuItem;
                        if (item.Text != "Align" && item.Text != "Flip" && item.Text != "Order" && item.Text != "Rotate")
                        {
                            diagram1.ContextMenuStrip.Items.Remove(item);

                        }
                    }
                    i--;
                }
            }
        }

        private void diagram1_MouseUp(object sender, MouseEventArgs e)
        {
            diagram1.Controller.ActiveTool = null;
        }
    }
}
